; randomizer.s
; random number generator and random piece generator for LJ65

;;; Copyright (C) 2009 Damian Yerrick
;
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 3
;   of the License, or (at your option) any later version.
;
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to 
;     Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;     Boston, MA  02111-1307, USA.
;
;   Visit http://www.pineight.com/ for more information.


.p02
.importzp rand_history, rand0, rand1, rand2, rand3, cur_turn, next_piece
.export tgmstyle_init, tgmstyle_rand, random

.segment "CODE"
;; random
; Uses the crc32 polynomial to generate Y random bits
; as the low_order bits of rand3.
; Average 48 cycles per bit.
;
.proc random
  asl rand3
  rol rand2
  rol rand1
  rol rand0
  bcc @no_xor
  lda rand0
  eor #$04
  sta rand0
  lda rand1
  eor #$c1
  sta rand1
  lda rand2
  eor #$1d
  sta rand2
  lda rand3
  eor #$b7
  sta rand3
@no_xor:
  dey
  bne random
  rts
.endproc

;;
; Chooses one of the 4 least recent pieces out of the 7.
.proc tgmstyle_rand
  ldy #2
  jsr random
  and #$03
  asl a
  ora cur_turn
  adc #4
  tay
  ldx cur_turn
  lda rand_history+2,y
  sta next_piece,x
@loop:
  lda rand_history,y
  sta rand_history+2,y
  dey
  dey
  bpl @loop
  lda next_piece,x
  sta rand_history,x
  rts
.endproc

;;
; Sets up O, S, and Z as the most recent pieces for tgmstyle_rand.
.proc tgmstyle_init
  ldy #0
  lda cur_turn
  ora #12
  tax
@loop:
  lda starting_most_recent,y
  sta rand_history,x
  iny
  dex
  dex
  bpl @loop
  rts
.endproc

starting_most_recent:
  .byt 0, 1, 2, 5, 3, 4, 6   ; I, J, L, T, O, S, Z
